#![allow(deprecated)]
use std::fmt;
use std::str;
/// If a CSV data source is still being split, the timestamp type is not known.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum WeakTimestampType {
    #[serde(rename = "ABSOLUTE")]
    Absolute,
    #[serde(rename = "RELATIVE")]
    Relative,
    #[serde(rename = "PENDING")]
    Pending,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl WeakTimestampType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            WeakTimestampType::Absolute => "ABSOLUTE",
            WeakTimestampType::Relative => "RELATIVE",
            WeakTimestampType::Pending => "PENDING",
            WeakTimestampType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for WeakTimestampType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for WeakTimestampType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for WeakTimestampType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<WeakTimestampType, conjure_object::plain::ParseEnumError> {
        match v {
            "ABSOLUTE" => Ok(WeakTimestampType::Absolute),
            "RELATIVE" => Ok(WeakTimestampType::Relative),
            "PENDING" => Ok(WeakTimestampType::Pending),
            v => v.parse().map(|v| WeakTimestampType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for WeakTimestampType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<WeakTimestampType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the WeakTimestampType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
